Index: code/branches/doc/src/libraries/core/command/ConsoleCommand.cc
===================================================================
--- code/branches/doc/src/libraries/core/command/ConsoleCommand.cc	(revision 7347)
+++ code/branches/doc/src/libraries/core/command/ConsoleCommand.cc	(revision 7352)
@@ -27,4 +27,9 @@
  */
 
+/**
+    @file
+    @brief Implementation of the ConsoleCommand class.
+*/
+
 #include "ConsoleCommand.h"
 
@@ -36,4 +41,11 @@
 namespace orxonox
 {
+    /**
+        @brief Constructor: Initializes all values and registers the command.
+        @param group The group of the command
+        @param name The name of the command
+        @param executor The executor of the command
+        @param bInitialized If true, the executor is used for both, the definition of the function-header AND to executute the command. If false, the command is inactive and needs to be assigned a function before it can be used.
+    */
     ConsoleCommand::ConsoleCommand(const std::string& group, const std::string& name, const ExecutorPtr& executor, bool bInitialized)
     {
@@ -45,9 +57,6 @@
         this->baseFunctor_ = executor->getFunctor();
 
-        this->argumentCompleter_[0] = 0;
-        this->argumentCompleter_[1] = 0;
-        this->argumentCompleter_[2] = 0;
-        this->argumentCompleter_[3] = 0;
-        this->argumentCompleter_[4] = 0;
+        for (size_t i = 0; i < MAX_FUNCTOR_ARGUMENTS; ++i)
+            this->argumentCompleter_[i] = 0;
 
         this->keybindMode_ = KeybindMode::OnPress;
@@ -60,4 +69,7 @@
     }
 
+    /**
+        @brief Destructor: Unregisters the command.
+    */
     ConsoleCommand::~ConsoleCommand()
     {
@@ -65,4 +77,7 @@
     }
 
+    /**
+        @brief Registers the command with the same name, but without group, as shortcut.
+    */
     ConsoleCommand& ConsoleCommand::addShortcut()
     {
@@ -71,4 +86,7 @@
     }
 
+    /**
+        @brief Registers the command with an alias as shortcut.
+    */
     ConsoleCommand& ConsoleCommand::addShortcut(const std::string&  name)
     {
@@ -77,4 +95,7 @@
     }
 
+    /**
+        @brief Registers the command in a different group but with the same name.
+    */
     ConsoleCommand& ConsoleCommand::addGroup(const std::string& group)
     {
@@ -83,4 +104,7 @@
     }
 
+    /**
+        @brief Registers an alias of the command in a different group with a different name.
+    */
     ConsoleCommand& ConsoleCommand::addGroup(const std::string& group, const std::string&  name)
     {
@@ -89,4 +113,13 @@
     }
 
+    /**
+        @brief Returns true if the command can be executed right now.
+
+        This returns only true, if the following conditions are met:
+         - The command is active
+         - The command has an executor
+         - The executor has a functor
+         - The functor is static or has an object
+    */
     bool ConsoleCommand::isActive() const
     {
@@ -94,4 +127,7 @@
     }
 
+    /**
+        @brief Returns true if the current state of the game matches the required access level.
+    */
     bool ConsoleCommand::hasAccess() const
     {
@@ -110,14 +146,22 @@
     }
 
+    /**
+        @brief Returns true if the headers of the given functor match the declaration of this command.
+    */
     bool ConsoleCommand::headersMatch(const FunctorPtr& functor)
     {
+        // get the minimum of the number of parameters of both commands
         unsigned int minparams = std::min(this->baseFunctor_->getParamCount(), functor->getParamCount());
 
+        // if the reduced headers don't match -> return false
         if (this->baseFunctor_->getHeaderIdentifier(minparams) != functor->getHeaderIdentifier(minparams))
             return false;
+        // if the reduced headers match and the new functor has less or equal parameters -> return true
         else if (functor->getParamCount() <= this->baseFunctor_->getParamCount())
             return true;
+        // the headers match but the new functor has more arguments and there is no executor with default-values -> return false
         else if (!this->executor_)
             return false;
+        // the headers match but the new functor has more arguments, check if the executor has enough default-values
         else
         {
@@ -135,12 +179,19 @@
     }
 
+    /**
+        @brief Returns true if the headers of the given executor match the declaration of this command.
+    */
     bool ConsoleCommand::headersMatch(const ExecutorPtr& executor)
     {
+        // get the minimum of the number of parameters of both commands
         unsigned int minparams = std::min(this->baseFunctor_->getParamCount(), executor->getParamCount());
 
+        // if the reduced headers don't match -> return false
         if (this->baseFunctor_->getHeaderIdentifier(minparams) != executor->getFunctor()->getHeaderIdentifier(minparams))
             return false;
+        // if the reduced headers match and the new functor has less or equal parameters -> return true
         else if (executor->getParamCount() <= this->baseFunctor_->getParamCount())
             return true;
+        // the headers match but the new functor has more arguments, check if the new executor has enough default-values
         else
         {
@@ -158,8 +209,16 @@
     }
 
+    /**
+        @brief Changes the executor.
+        @param executor The new executor
+        @param bForce If true, the executor is always assigned, even if the headers don't match
+        @return Returns true if the assignment was successful
+    */
     bool ConsoleCommand::setFunction(const ExecutorPtr& executor, bool bForce)
     {
+        // assign the executor if a) it's a null-pointer, b) its functor is a null-pointer, c) it's forced, d) the headers match
         if (!executor || !executor->getFunctor() || bForce || this->headersMatch(executor))
         {
+            // assign the executor and clear the object stack (because it's also a new function)
             this->executor_ = executor;
             this->objectStack_.clear();
@@ -173,8 +232,16 @@
     }
 
+    /**
+        @brief Changes the functor of the current executor.
+        @param functor The new functor
+        @param bForce If true, the functor is always assigned, even if the headers don't match
+        @return Returns true if the assignment was successful
+    */
     bool ConsoleCommand::setFunction(const FunctorPtr& functor, bool bForce)
     {
+        // assign the functor if a) it's a null-pointer, b) it's forced, c) the headers match
         if (!functor || bForce || this->headersMatch(functor))
         {
+            // assign the functor (create a new executor if necessary) and clear the object stack
             if (this->executor_)
                 this->executor_->setFunctor(functor);
@@ -192,6 +259,12 @@
     }
 
+    /**
+        @brief Pushes a new executor to the command-stack.
+        @param executor The new executor
+        @param bForce If true, the executor is always assigned, even if the headers don't match
+    */
     void ConsoleCommand::pushFunction(const ExecutorPtr& executor, bool bForce)
     {
+        // prepare the old function to be put on the stack
         Command command;
         command.executor_ = this->executor_;
@@ -200,10 +273,17 @@
         command.objectStack_ = this->objectStack_;
 
+        // check if the new executor can be assigned and push the old function to the stack
         if (this->setFunction(executor, bForce))
             this->commandStack_.push(command);
     }
 
+    /**
+        @brief Pushes a new functor to the command-stack.
+        @param functor The new functor
+        @param bForce If true, the functor is always assigned, even if the headers don't match
+    */
     void ConsoleCommand::pushFunction(const FunctorPtr& functor, bool bForce)
     {
+        // prepare the old function to be put on the stack
         Command command;
         command.executor_ = this->executor_;
@@ -212,8 +292,12 @@
         command.objectStack_ = this->objectStack_;
 
+        // check if the new functor can be assigned and push the old function to the stack
         if (this->setFunction(functor, bForce))
             this->commandStack_.push(command);
     }
 
+    /**
+        @brief Pushes a copy of the current executor and functor on the stack.
+    */
     void ConsoleCommand::pushFunction()
     {
@@ -224,13 +308,20 @@
     }
 
+    /**
+        @brief Removes the current function from the stack and restores the old state.
+    */
     void ConsoleCommand::popFunction()
     {
         Command command;
+
+        // check if there's a function on the stack
         if (!this->commandStack_.empty())
         {
+            // yes it is - assign it to command and remove it from the stack
             command = this->commandStack_.top();
             this->commandStack_.pop();
         }
 
+        // restore the old executor (and also restore its functor in case this was changed in the meantime)
         this->executor_ = command.executor_;
         if (command.executor_)
@@ -239,4 +330,7 @@
     }
 
+    /**
+        @brief Sets the functor to NULL (which also deactivates the command).
+    */
     void ConsoleCommand::resetFunction()
     {
@@ -246,4 +340,7 @@
     }
 
+    /**
+        @brief Returns the current executor which can be used to execute the command.
+    */
     const ExecutorPtr& ConsoleCommand::getExecutor() const
     {
@@ -251,10 +348,17 @@
     }
 
+    /**
+        @brief Changes the current object that is used to execute member-functions.
+        @return Returns true if the object was successfully changed
+    */
     bool ConsoleCommand::setObject(void* object)
     {
-        if (this->executor_)
-        {
+        // check if there's an executor
+        if (this->executor_)
+        {
+            // check if there's a functor
             if (this->executor_->getFunctor())
             {
+                // change the object
                 this->executor_->getFunctor()->setRawObjectPointer(object);
                 return true;
@@ -269,4 +373,7 @@
     }
 
+    /**
+        @brief Push a new object to the object-stack.
+    */
     void ConsoleCommand::pushObject(void* object)
     {
@@ -276,4 +383,7 @@
     }
 
+    /**
+        @brief Removes the current object from the stack an restores the old object.
+    */
     void ConsoleCommand::popObject()
     {
@@ -287,4 +397,7 @@
     }
 
+    /**
+        @brief Returns the current object pointer that is used to execute member-functions.
+    */
     void* ConsoleCommand::getObject() const
     {
@@ -295,8 +408,11 @@
     }
 
-    ConsoleCommand& ConsoleCommand::defaultValues(const MultiType& param1)
-    {
-        if (this->executor_)
-            this->executor_->setDefaultValues(param1);
+    /**
+        @brief Changes the default values of the current executor.
+    */
+    ConsoleCommand& ConsoleCommand::defaultValues(const MultiType& arg1)
+    {
+        if (this->executor_)
+            this->executor_->setDefaultValues(arg1);
         else
             COUT(1) << "Error: Can't set default values in console command \"" << this->baseName_ << "\", no executor set." << std::endl;
@@ -305,8 +421,11 @@
     }
 
-    ConsoleCommand& ConsoleCommand::defaultValues(const MultiType& param1, const MultiType& param2)
-    {
-        if (this->executor_)
-            this->executor_->setDefaultValues(param1, param2);
+    /**
+        @brief Changes the default values of the current executor.
+    */
+    ConsoleCommand& ConsoleCommand::defaultValues(const MultiType& arg1, const MultiType& arg2)
+    {
+        if (this->executor_)
+            this->executor_->setDefaultValues(arg1, arg2);
         else
             COUT(1) << "Error: Can't set default values in console command \"" << this->baseName_ << "\", no executor set." << std::endl;
@@ -315,8 +434,11 @@
     }
 
-    ConsoleCommand& ConsoleCommand::defaultValues(const MultiType& param1, const MultiType& param2, const MultiType& param3)
-    {
-        if (this->executor_)
-            this->executor_->setDefaultValues(param1, param2, param3);
+    /**
+        @brief Changes the default values of the current executor.
+    */
+    ConsoleCommand& ConsoleCommand::defaultValues(const MultiType& arg1, const MultiType& arg2, const MultiType& arg3)
+    {
+        if (this->executor_)
+            this->executor_->setDefaultValues(arg1, arg2, arg3);
         else
             COUT(1) << "Error: Can't set default values in console command \"" << this->baseName_ << "\", no executor set." << std::endl;
@@ -325,8 +447,11 @@
     }
 
-    ConsoleCommand& ConsoleCommand::defaultValues(const MultiType& param1, const MultiType& param2, const MultiType& param3, const MultiType& param4)
-    {
-        if (this->executor_)
-            this->executor_->setDefaultValues(param1, param2, param3, param4);
+    /**
+        @brief Changes the default values of the current executor.
+    */
+    ConsoleCommand& ConsoleCommand::defaultValues(const MultiType& arg1, const MultiType& arg2, const MultiType& arg3, const MultiType& arg4)
+    {
+        if (this->executor_)
+            this->executor_->setDefaultValues(arg1, arg2, arg3, arg4);
         else
             COUT(1) << "Error: Can't set default values in console command \"" << this->baseName_ << "\", no executor set." << std::endl;
@@ -335,8 +460,11 @@
     }
 
-    ConsoleCommand& ConsoleCommand::defaultValues(const MultiType& param1, const MultiType& param2, const MultiType& param3, const MultiType& param4, const MultiType& param5)
-    {
-        if (this->executor_)
-            this->executor_->setDefaultValues(param1, param2, param3, param4, param5);
+    /**
+        @brief Changes the default values of the current executor.
+    */
+    ConsoleCommand& ConsoleCommand::defaultValues(const MultiType& arg1, const MultiType& arg2, const MultiType& arg3, const MultiType& arg4, const MultiType& arg5)
+    {
+        if (this->executor_)
+            this->executor_->setDefaultValues(arg1, arg2, arg3, arg4, arg5);
         else
             COUT(1) << "Error: Can't set default values in console command \"" << this->baseName_ << "\", no executor set." << std::endl;
@@ -345,8 +473,13 @@
     }
 
-    ConsoleCommand& ConsoleCommand::defaultValue(unsigned int index, const MultiType& param)
-    {
-        if (this->executor_)
-            this->executor_->setDefaultValue(index, param);
+    /**
+        @brief Changes the default value of the argument with given index of the current executor.
+        @param index The index of the argument (the first argument has index 0)
+        @param arg The new default value
+    */
+    ConsoleCommand& ConsoleCommand::defaultValue(unsigned int index, const MultiType& arg)
+    {
+        if (this->executor_)
+            this->executor_->setDefaultValue(index, arg);
         else
             COUT(1) << "Error: Can't set default values in console command \"" << this->baseName_ << "\", no executor set." << std::endl;
@@ -355,22 +488,33 @@
     }
 
-    ConsoleCommand& ConsoleCommand::argumentCompleter(unsigned int param, ArgumentCompleter* completer)
-    {
-        if (param < 5)
-            this->argumentCompleter_[param] = completer;
-        else
-            COUT(2) << "Warning: Couldn't add autocompletion-function for param " << param << " in console command \"" << this->baseName_ << "\": index out of bound." << std::endl;
-
-        return *this;
-    }
-
-    ArgumentCompleter* ConsoleCommand::getArgumentCompleter(unsigned int param) const
-    {
-        if (param < 5)
-            return this->argumentCompleter_[param];
+    /**
+        @brief Changes the argument completer for the given argument.
+        @param index The index of the argument (the first argument has index 0)
+        @param completer The new argument completer
+    */
+    ConsoleCommand& ConsoleCommand::argumentCompleter(unsigned int index, ArgumentCompleter* completer)
+    {
+        if (index < 5)
+            this->argumentCompleter_[index] = completer;
+        else
+            COUT(2) << "Warning: Couldn't add autocompletion-function for index " << index << " in console command \"" << this->baseName_ << "\": index out of bound." << std::endl;
+
+        return *this;
+    }
+
+    /**
+        @brief Returns the argument completer for the argument with given index.
+    */
+    ArgumentCompleter* ConsoleCommand::getArgumentCompleter(unsigned int index) const
+    {
+        if (index < 5)
+            return this->argumentCompleter_[index];
         else
             return 0;
     }
 
+    /**
+        @brief Sets the description of this command.
+    */
     ConsoleCommand& ConsoleCommand::description(const std::string& description)
     {
@@ -380,4 +524,7 @@
     }
 
+    /**
+        @brief Returns the description of this command.
+    */
     const std::string& ConsoleCommand::getDescription() const
     {
@@ -385,22 +532,31 @@
     }
 
-    ConsoleCommand& ConsoleCommand::descriptionParam(unsigned int param, const std::string& description)
-    {
-        if (param < MAX_FUNCTOR_ARGUMENTS)
-        {
-            this->descriptionParam_[param] = std::string("ConsoleCommandDescription::" + this->baseName_ + "::param" + multi_cast<std::string>(param));
-            AddLanguageEntry(this->descriptionParam_[param], description);
-        }
-        return *this;
-    }
-
-    const std::string& ConsoleCommand::getDescriptionParam(unsigned int param) const
-    {
-        if (param < MAX_FUNCTOR_ARGUMENTS)
-            return GetLocalisation_noerror(this->descriptionParam_[param]);
+    /**
+        @brief Sets the description for an argument with given index.
+    */
+    ConsoleCommand& ConsoleCommand::descriptionParam(unsigned int index, const std::string& description)
+    {
+        if (index < MAX_FUNCTOR_ARGUMENTS)
+        {
+            this->descriptionParam_[index] = std::string("ConsoleCommandDescription::" + this->baseName_ + "::param" + multi_cast<std::string>(index));
+            AddLanguageEntry(this->descriptionParam_[index], description);
+        }
+        return *this;
+    }
+
+    /**
+        @brief Returns the description for the argument with given index.
+    */
+    const std::string& ConsoleCommand::getDescriptionParam(unsigned int index) const
+    {
+        if (index < MAX_FUNCTOR_ARGUMENTS)
+            return GetLocalisation_noerror(this->descriptionParam_[index]);
 
         return this->descriptionParam_[0];
     }
 
+    /**
+        @brief Sets the description for the return-value.
+    */
     ConsoleCommand& ConsoleCommand::descriptionReturnvalue(const std::string& description)
     {
@@ -410,17 +566,29 @@
     }
 
-    const std::string& ConsoleCommand::getDescriptionReturnvalue(int param) const
+    /**
+        @brief Returns the description for the return-value.
+    */
+    const std::string& ConsoleCommand::getDescriptionReturnvalue(int index) const
     {
         return GetLocalisation_noerror(this->descriptionReturnvalue_);
     }
 
+    /**
+        @brief Returns the command with given group an name.
+        @param group The group of the requested command
+        @param name The group of the requested command
+        @param bPrintError If true, an error is printed if the command doesn't exist
+    */
     /* static */ const ConsoleCommand* ConsoleCommand::getCommand(const std::string& group, const std::string& name, bool bPrintError)
     {
+        // find the group
         std::map<std::string, std::map<std::string, ConsoleCommand*> >::const_iterator it_group = ConsoleCommand::getCommandMap().find(group);
         if (it_group != ConsoleCommand::getCommandMap().end())
         {
+            // find the name
             std::map<std::string, ConsoleCommand*>::const_iterator it_name = it_group->second.find(name);
             if (it_name != it_group->second.end())
             {
+                // return the pointer
                 return it_name->second;
             }
@@ -436,4 +604,10 @@
     }
 
+    /**
+        @brief Returns the command with given group an name in lowercase.
+        @param group The group of the requested command in lowercase
+        @param name The group of the requested command in lowercase
+        @param bPrintError If true, an error is printed if the command doesn't exist
+    */
     /* static */ const ConsoleCommand* ConsoleCommand::getCommandLC(const std::string& group, const std::string& name, bool bPrintError)
     {
@@ -441,10 +615,13 @@
         std::string nameLC = getLowercase(name);
 
+        // find the group
         std::map<std::string, std::map<std::string, ConsoleCommand*> >::const_iterator it_group = ConsoleCommand::getCommandMapLC().find(groupLC);
         if (it_group != ConsoleCommand::getCommandMapLC().end())
         {
+            // find the name
             std::map<std::string, ConsoleCommand*>::const_iterator it_name = it_group->second.find(nameLC);
             if (it_name != it_group->second.end())
             {
+                // return the pointer
                 return it_name->second;
             }
@@ -460,4 +637,7 @@
     }
 
+    /**
+        @brief Returns the static map that stores all console commands.
+    */
     /* static */ std::map<std::string, std::map<std::string, ConsoleCommand*> >& ConsoleCommand::getCommandMap()
     {
@@ -466,4 +646,7 @@
     }
 
+    /**
+        @brief Returns the static map that stores all console commands in lowercase.
+    */
     /* static */ std::map<std::string, std::map<std::string, ConsoleCommand*> >& ConsoleCommand::getCommandMapLC()
     {
@@ -472,4 +655,7 @@
     }
 
+    /**
+        @brief Registers a new command with given group an name by adding it to the command map.
+    */
     /* static */ void ConsoleCommand::registerCommand(const std::string& group, const std::string& name, ConsoleCommand* command)
     {
@@ -477,4 +663,5 @@
             return;
 
+        // check if a command with this name already exists
         if (ConsoleCommand::getCommand(group, name) != 0)
         {
@@ -486,4 +673,5 @@
         else
         {
+            // add the command to the map
             ConsoleCommand::getCommandMap()[group][name] = command;
             ConsoleCommand::getCommandMapLC()[getLowercase(group)][getLowercase(name)] = command;
@@ -491,10 +679,16 @@
     }
 
+    /**
+        @brief Removes the command from the command map.
+    */
     /* static */ void ConsoleCommand::unregisterCommand(ConsoleCommand* command)
     {
+        // iterate through all groups
         for (std::map<std::string, std::map<std::string, ConsoleCommand*> >::iterator it_group = ConsoleCommand::getCommandMap().begin(); it_group != ConsoleCommand::getCommandMap().end(); )
         {
+            // iterate through all commands of each group
             for (std::map<std::string, ConsoleCommand*>::iterator it_name = it_group->second.begin(); it_name != it_group->second.end(); )
             {
+                // erase the command
                 if (it_name->second == command)
                     it_group->second.erase(it_name++);
@@ -503,4 +697,5 @@
             }
 
+            // erase the group if it is empty now
             if (it_group->second.empty())
                 ConsoleCommand::getCommandMap().erase(it_group++);
@@ -509,8 +704,13 @@
         }
 
+        // now the same for the lowercase-map:
+
+        // iterate through all groups
         for (std::map<std::string, std::map<std::string, ConsoleCommand*> >::iterator it_group = ConsoleCommand::getCommandMapLC().begin(); it_group != ConsoleCommand::getCommandMapLC().end(); )
         {
+            // iterate through all commands of each group
             for (std::map<std::string, ConsoleCommand*>::iterator it_name = it_group->second.begin(); it_name != it_group->second.end(); )
             {
+                // erase the command
                 if (it_name->second == command)
                     it_group->second.erase(it_name++);
@@ -519,4 +719,5 @@
             }
 
+            // erase the group if it is empty now
             if (it_group->second.empty())
                 ConsoleCommand::getCommandMapLC().erase(it_group++);
@@ -526,6 +727,10 @@
     }
 
+    /**
+        @brief Deletes all commands
+    */
     /* static */ void ConsoleCommand::destroyAll()
     {
+        // delete entries until the map is empty
         while (!ConsoleCommand::getCommandMap().empty() && !ConsoleCommand::getCommandMap().begin()->second.empty())
             delete ConsoleCommand::getCommandMap().begin()->second.begin()->second;
